<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement OSB
#						Version : 2.7 (rvision 50032)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.1.4
#						Compatibilit plateforme : V2
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						05/08/2013
#						Contact : support@osb.pf
#
#####################################################################################################

/**
 * Processing user return to shop confirmation.
 */

if(!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

require_once(CLASSPATH . 'payment/ps_osb.cfg.php');
require_once(CLASSPATH . 'payment/ps_osb.php');
require_once(CLASSPATH . 'ps_order.php');

global $OSB_LANG, $vmLogger;

$ps_osb = new ps_osb();

$response = new OsbResponse($_REQUEST, OSB_CTX_MODE, OSB_KEY_TEST, OSB_KEY_PROD);

// check request authenticity
if(! $response->isAuthentified()) {
	vmRedirect(URL . 'index.php?option=com_virtuemart&page=shop.cart&Itemid=1');
	die();
}

// retrieve order from db
$db = new ps_DB();
$orderId = $db->getEscaped($response->get('order_id'));
$db->query('SELECT order_status_code FROM #__{vm}_order_history WHERE order_id='.$orderId.' ORDER BY date_added DESC');

if($db->num_rows() <= 0) {
	// order not found
	$message  = '<span style="color:red">' . $OSB_LANG->_('OSB_TECHNICAL_ERROR') . '</span>';
	echo $message;
} else {
	$db->next_record();
	
	// how to pass to prod notice
	if($response->get('ctx_mode') == 'TEST' ) {
		$vmLogger->info($OSB_LANG->_('OSB_SHOP_TO_PROD_INFO') . '<a href="https://secure.osb.pf/html/faq/prod" target="_blank">https://secure.osb.pf/html/faq/prod</a>');
	}
	
	if($db->f('order_status_code') == 'P') {
		// order not confirmed yet
		
		// notify customer ?
		$notify = (OSB_NOTIFY_CUSTOMER_ENABLED == '1');
	
		if($response->isAcceptedPayment()) {
			// save order with verified status ...
			$ps_osb->update_order($response, OSB_VERIFIED_STATUS, $notify);
	
			if($response->get('ctx_mode') == 'TEST' ) {
				// the server URL does not worked correctly, let's show warning on TEST mode
				$vmLogger->warning($OSB_LANG->_('OSB_CHECK_URL_WARN') . '<br />' . $OSB_LANG->_('OSB_CHECK_URL_WARN_DETAILS'));
			}
	
			// ... and show success message
			echo '<h2>'.$OSB_LANG->_('OSB_THANKYOU').'</h2>';
			echo '<p>';
			echo '  <a href="index.php?option=com_virtuemart&page=account.order_details&order_id='.$orderId.'&Itemid=1">' . $OSB_LANG->_('OSB_SHOW_ORDER_DETAILS') . '</a>';
			echo '</p>';
			
		} else {
			// payment failed, save order with invalid status ...
			$ps_osb->update_order($response, OSB_INVALID_STATUS);
	
			// ... and show failure message
			echo '<h2>' . $OSB_LANG->_('OSB_PAYMENT_ERROR') . '</h2>';
			echo '<p>';
			echo '  <a href="index.php?option=com_virtuemart&page=account.index&Itemid=1">' . $OSB_LANG->_('OSB_RETURN_TO_ORDERS_HISTORY') . '</a>';
			echo '</p>';
		}
	}
	
	else {
		// order already saved 
		
		if($db->f('order_status_code') == OSB_VERIFIED_STATUS && $response->isAcceptedPayment()) {
			// payment success reconfirmed, just show success message
			echo '<h2>' . $OSB_LANG->_('OSB_THANKYOU') . '</h2>';
			echo '<p>';
			echo '  <a href="index.php?option=com_virtuemart&page=account.order_details&order_id='.$orderId.'&Itemid=1">' . $OSB_LANG->_('OSB_SHOW_ORDER_DETAILS') . '</a>';
			echo '</p>';
	
		} elseif($db->f('order_status_code') == OSB_INVALID_STATUS && !$response->isAcceptedPayment()) {
			// payment failure reconfirmed, just show failure message
			echo '<h2>' . $OSB_LANG->_('OSB_PAYMENT_ERROR') . '</h2>';
			echo '<p>';
			echo '  <a href="index.php?option=com_virtuemart&page=account.index&Itemid=1">' . $OSB_LANG->_('OSB_RETURN_TO_ORDERS_HISTORY') . '</a>';
			echo '</p>';
			
		} else {
			// error ! order status not correspending to payment result
			$message  = '<span style="color:red">' . $OSB_LANG->_('OSB_TECHNICAL_ERROR') . '</span>';
			echo $message;
		}
	}
}
?>